"""autogenerated by genmsg_py from SetMultiWaveformRequest.msg. Do not edit."""
import roslib.message
import struct

import ethercat_trigger_controllers.msg

class SetMultiWaveformRequest(roslib.message.Message):
  _md5sum = "bfedad8205348a9bcc90e6ae4b778d86"
  _type = "ethercat_trigger_controllers/SetMultiWaveformRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """MultiWaveform waveform

================================================================================
MSG: ethercat_trigger_controllers/MultiWaveform
# Transitions will occur at k * period + zero_offset + transitions[j].time, where j and
# k are integers.

float64 period # Period of the waveform in seconds.
float64 zero_offset # Time corresponding to a time of 0 in times[] in seconds
MultiWaveformTransition[] transitions # Transitions in the waveform. Transition times should be in increasing order, and be between 0 (inclusive) and period (exclusive)

================================================================================
MSG: ethercat_trigger_controllers/MultiWaveformTransition
# Used to specify a transition in the SetMultiWaveform service.

float64 time # Transition time after start of period.
uint32 value # Value of the digital output after the transition time.
string topic # Topic to publish the transition timestamp to, or empty string if the transition should not be published.

"""
  __slots__ = ['waveform']
  _slot_types = ['ethercat_trigger_controllers/MultiWaveform']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       waveform
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SetMultiWaveformRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.waveform is None:
        self.waveform = ethercat_trigger_controllers.msg.MultiWaveform()
    else:
      self.waveform = ethercat_trigger_controllers.msg.MultiWaveform()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_2d.pack(_x.waveform.period, _x.waveform.zero_offset))
      length = len(self.waveform.transitions)
      buff.write(_struct_I.pack(length))
      for val1 in self.waveform.transitions:
        _x = val1
        buff.write(_struct_dI.pack(_x.time, _x.value))
        _x = val1.topic
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.waveform is None:
        self.waveform = ethercat_trigger_controllers.msg.MultiWaveform()
      end = 0
      _x = self
      start = end
      end += 16
      (_x.waveform.period, _x.waveform.zero_offset,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.waveform.transitions = []
      for i in range(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        _x = val1
        start = end
        end += 12
        (_x.time, _x.value,) = _struct_dI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.topic = str[start:end]
        self.waveform.transitions.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_2d.pack(_x.waveform.period, _x.waveform.zero_offset))
      length = len(self.waveform.transitions)
      buff.write(_struct_I.pack(length))
      for val1 in self.waveform.transitions:
        _x = val1
        buff.write(_struct_dI.pack(_x.time, _x.value))
        _x = val1.topic
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.waveform is None:
        self.waveform = ethercat_trigger_controllers.msg.MultiWaveform()
      end = 0
      _x = self
      start = end
      end += 16
      (_x.waveform.period, _x.waveform.zero_offset,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.waveform.transitions = []
      for i in range(0, length):
        val1 = ethercat_trigger_controllers.msg.MultiWaveformTransition()
        _x = val1
        start = end
        end += 12
        (_x.time, _x.value,) = _struct_dI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.topic = str[start:end]
        self.waveform.transitions.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_2d = struct.Struct("<2d")
_struct_dI = struct.Struct("<dI")
"""autogenerated by genmsg_py from SetMultiWaveformResponse.msg. Do not edit."""
import roslib.message
import struct


class SetMultiWaveformResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "ethercat_trigger_controllers/SetMultiWaveformResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       success,status_message
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SetMultiWaveformResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
class SetMultiWaveform(roslib.message.ServiceDefinition):
  _type          = 'ethercat_trigger_controllers/SetMultiWaveform'
  _md5sum = 'cbb7e900a71a9a437da9999c8d39fff4'
  _request_class  = SetMultiWaveformRequest
  _response_class = SetMultiWaveformResponse
